!c Description:
!c   ١ϡ, Ǯϳشؿ G ʿջƳ롼
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-02-25    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_mingibbs
  interface
     
     recursive subroutine mingibbs(temp, pres, emol, struct, property, mol_nxt, mol_pre, gibbs)
       use prm_type, only: type_property
       real(8), intent(in)               :: temp  
       real(8), intent(in)               :: pres
       real(8), intent(in)               :: emol(:)
       real(8), intent(in)               :: struct(:,:)
       real(8), intent(in), optional     :: mol_pre(:)
       real(8), intent(out), optional    :: gibbs
       real(8), intent(out)              :: mol_nxt(:)
       type(type_property), intent(inout):: property(:)
     end subroutine mingibbs
     
  end interface
end module interface_mingibbs





recursive subroutine mingibbs(temp, pres, emol, struct, property, mol_nxt, mol_pre, gibbs)
  use prm_type, only: type_property
  use prm_common, only: min, cnv
  use interface_lu
  use interface_chk_emol
  use interface_chk_equiv
  use interface_chk_mol
  use interface_chk_mu
  use interface_chk_react
  use interface_chk_converge
  use interface_chk_singular
  use interface_matrix_coeff
  use interface_matrix_const
  use interface_matrix_resolv
  use interface_equivmol
  use interface_initmol
  use interface_gibbs_energy
  use interface_packing
  use interface_unpacking
  use interface_mingibbs
  use interface_display
  use interface_mol2emol
  use interface_def_phase

  implicit none
  real(8), intent(in)               :: temp  
  real(8), intent(in)               :: pres
  real(8), intent(in)               :: emol(:)
  real(8), intent(in)               :: struct(:,:)
  real(8), intent(in), optional     :: mol_pre(:)
  real(8), intent(out), optional    :: gibbs
  real(8), intent(out)              :: mol_nxt(:)
  type(type_property), intent(inout):: property(:)

  real(8)                           :: gibbs_pre
  real(8)                           :: gibbs_nxt
  real(8), allocatable              :: mol(:)
!  real(8), allocatable              :: mol_ini(:)
  real(8), allocatable              :: mu(:)
  real(8), allocatable              :: mu0(:)
  real(8), allocatable              :: A(:,:)
  real(8), allocatable              :: B(:)
  real(8), allocatable              :: emol_np(:)
  real(8), allocatable              :: struct_np(:,:)
!  real(8), allocatable              :: mol_ini_np(:)
  real(8), allocatable              :: mol_pre_np(:)
  integer(8)                        :: emax
  integer(8)                        :: info
  logical, allocatable              :: ssw(:)
  logical, allocatable              :: esw(:)
  logical                           :: sw
  logical                           :: cnvsw
  type(type_property), allocatable  :: property_np(:)
  
  !ɽ
!  write(*,*) ""
!  write(*,*) "call mingibbs", temp, pres
!  write(*,*) ""
!  write(*,*) property%name
  
  !
  emax = size(struct, 2)
!  if (present(mol_pre)) then 
!     allocate(mol_ini(size(mol_pre, 1)))
!     mol_ini = mol_pre
!  end if

  !ֹդľ
  call def_phase(property)
!  write(*,*) "phase", property%phase

  !ͤ⾯ʤʤäǤ
  call chk_emol(emol, struct, min, ssw, esw, sw)
  if (sw) then 
!     write(*,*) "call chk_emol"
     call rcv_mingibbs
     return
  end if
  
  !Ž꤬ñ¸ߤƤʤȤå
  call chk_equiv(temp, pres, property, ssw, sw)
  if (sw) then
!     write(*,*) "call chk_equiv"
     call rcv_mingibbs
     return
  end if
  
  !ȿ򵯤뤫(ȿʪ·äƤ뤫)ݤΥå. 
  call chk_react(property, ssw, sw)
  if (sw) then 
!     write(*,*) "call chk_react"
     call rcv_mingibbs
     return
  end if
  
  !Ϥ줿ǿ򸵤˽
!  write(*,*) "call initmol"
  if (present(mol_pre)) then 
     call initmol(emol, struct, mol, mol_pre)  
  else
     call initmol(emol, struct, mol)  
  end if
  
  !ǤΥ֥ͳͥ륮
  call gibbs_energy(temp, pres, mol, property, mu = mu, mu0 = mu0, gibbs = gibbs_pre)
!  call display(mol, "")
!  call display(mu0, "ɸಽإݥƥ󥷥")
!  call display(mu, "إݥƥ󥷥")
  
  !Ǿ롼
  min_gibbs: do 
     
     !
     call matrix_coeff(mol, property%phase, struct, A)	
!     call display(A, "")
     
     !
     call matrix_const(temp, mol, mu, property%phase, struct, B)
!     call display(B, "")
    
     !ϢΩ
!     call matrix_resolv(A, B, info)
     call lu(A, B, sw)
     if (sw) then 
        call chk_singular(temp, pres, property, mol, ssw)
!        write(*,*) "call chk_singular"
        call rcv_mingibbs
        return
!        stop
!        write(*,*) "call chk_singular", info, emax
!        info = info - emax
!        call chk_singular(info, property%phase, ssw)
!        call rcv_mingibbs
!        return
     end if
!     call display(B, "")
     
     !ϢΩβ򤫤׻
     call equivmol(B, struct, property%phase, temp, mu, mol)
!     call display(mol, "ؼ¸")
     
     !ʿǤΥ֥ͳͥ륮
     deallocate(mu)
     call gibbs_energy(temp, pres, mol, property, mu = mu, gibbs = gibbs_nxt)
     
     !ʿξ֥å
!    call chk_mol(mol, Min, ssw, sw)
     call chk_mu(mol, mu, cnv, ssw, sw)
     if (sw) then 
!        write(*,*) "call chk_mol"
!        write(*,*) "call chk_mu"
        call rcv_mingibbs
        return
     end if
     
     !ǤäƤʤå
     call mol2emol(mol, struct, emol_np)
!     call display(emol_np, "¸")  
!     call display(emol, "¸()")    
     deallocate(emol_np)
     
     !«å
     call chk_converge(gibbs_pre, gibbs_nxt, cnv, cnvsw)
!     write(*,*) "gibbs check: ", gibbs_pre, gibbs_nxt, cnvsw
     if (cnvsw) then 
        call unpacking(mol, property%num, min, mol_nxt)
        if (present(gibbs)) gibbs = gibbs_nxt
        return 
     end if
     
     if (gibbs_pre < gibbs_nxt) then 
        call unpacking(mol, property%num, min, mol_nxt)
        if (present(gibbs)) gibbs = gibbs_pre 
        write(*,*) "gibbs_free_energy is increase"
     end if
     
     !롼פ󤹾
     gibbs_pre = gibbs_nxt
     
     deallocate(A, B)
  end do min_gibbs

contains

  subroutine rcv_mingibbs

    if (.not. allocated(esw)) then 
       allocate(esw(emax))
       esw = .true.
    end if

    call packing(emol, esw, emol_np)
    call packing(struct, ssw, esw, struct_np)
    call packing(property, ssw, property_np)
    
!    call display(emol_np, "(ѹ)")
!    call display(struct_np, "¤η(ѹ)")

    if (present(mol_pre)) then 
!       call packing(mol_ini, ssw, mol_ini_np)
       call packing(mol_pre, ssw, mol_pre_np)
!       call mingibbs(temp, pres, emol_np, &
!            & struct_np, property_np, mol_nxt, mol_ini_np, gibbs)
       call mingibbs(temp, pres, emol_np, &
            & struct_np, property_np, mol_nxt, mol_pre_np, gibbs)
    else    
       call mingibbs(temp, pres, emol_np, &
            & struct_np, property_np, mol_nxt, gibbs=gibbs)
    end if
  end subroutine rcv_mingibbs
  
  
end subroutine mingibbs
