!c Description:
!c  ǮٸΨη׻
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-06-02    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_lapserate
  interface

     subroutine lapserate(temp, pres, grav, molwt, dtdz)
       real(8), intent(in)    :: temp(:)
       real(8), intent(in)    :: pres(:)
       real(8), intent(in)    :: grav
       real(8), intent(in)    :: molwt(:)
       real(8), intent(out)   :: dtdz(:)
     end subroutine lapserate
     
  end interface
end module interface_lapserate



subroutine lapserate(temp, pres, grav, molwt, dtdz)
  use prm_phys, only: gasr
  use interface_display

  implicit none
  real(8), intent(in)    :: temp(:)
  real(8), intent(in)    :: pres(:)
  real(8), intent(in)    :: grav
  real(8), intent(in)    :: molwt(:)
  real(8), intent(out)   :: dtdz(:)
  real(8), allocatable   :: dt(:)
  real(8), allocatable   :: dp(:)
  integer(8)             :: step
  integer(8)             :: num
  
  
  !Υμ
  step = size(temp, 1)
  
  !
  allocate(dt(step), dp(step))
  
  !ٺη׻
  do num = 1, step - 1
     dt(num) = temp(num + 1) - temp(num)
  end do
  dt(step) = dt(step - 1)
  
  !Ϻη׻
  do num = 1, step - 1
     dp(num) = pres(num + 1) - pres(num)
  end do
  dp(step) = dp(step - 1)
  
  !ǮΨη׻
  dtdz = (dt * pres * grav * molwt) / ( dp * gasr * temp)  
  
!  call display(molwt, "g /mol")
!  call display(dtdz, "lapse rate")
  
  
  !β
  deallocate(dt, dp)
  
end subroutine lapserate
