!c Description:
!c   κ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-02-25    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_matrix_resolv
  interface
     
     subroutine matrix_resolv(A, B, info)
       real(8), intent(inout)    :: A(:,:)         !
       real(8), intent(inout)    :: B(:)           !/
       integer(8), intent(out), optional :: info
     end subroutine matrix_resolv
     
  end interface
end module interface_matrix_resolv




subroutine matrix_resolv(A, B, info)
  use interface_display
  use interface_display_residual
  use interface_residual
  use interface_stop

  implicit none
  real(8), intent(inout)    :: A(:,:)         !
  real(8), intent(inout)    :: B(:)           !/
  integer(8), intent(out), optional :: info

  real(8), allocatable      :: FA1(:,:)
  real(8), allocatable      :: FB1(:)
  real(8), allocatable      :: FA2(:,:)
  real(8), allocatable      :: FB2(:)
  real(8), allocatable      :: VW(:)
  real(8), allocatable      :: RR(:)
  integer(8), allocatable   :: IP(:)
  integer(8), parameter     :: EPSZ = 0.0d0
  integer(8)                :: ISW
  integer(8)                :: ICON
  integer(8)                :: IS
  integer(8)                :: num 
  integer(8)                :: i
  character(20)             :: error
  
  
!!!
!!!礭, γդ
!!!
  num = size(A, 1)  

  !礭
  allocate(FA1(num, num), &
       & FB1(num), &
       & FA2(num, num), &
       & FB2(num), &
       & VW(num), &
       & IP(num), &
       & RR(num))
  
!!!
!!!ѿͤ
!!!
  FA1 = A
  FB1 = B
  FA2 = A
  FB2 = B
  ISW = 1
  IP = (/(i, i = 1, num)/)
  VW = 0.0D0
  RR = 0.0D0
  if (present(info)) info = 0
  
!!!
!!!η׻
!!!
  !η׻. SSL II . 
  call DLAX(A, num, num, B, EPSZ, ISW, IS, VW, IP, ICON)
  
  !Υǥå. 
  if (ICON == 30000) then
     error = 'ICON is 30000'
     write(*,*) error
     stop
!     call stop(error)
  elseif (ICON == 20000) then
     error = 'ICON is 20000'
!     write(*,*) error
     if (present(info)) info = minloc(abs(FB2), 1)
     call display(FB2, "matrix_resolv, FB2")
     write(*,*) "matrix_resolv, info ", info
     return
!     stop
!     call stop(error)
  end if

  !ȿ
  call DLAXR(B, FA1, num, num, A, FB1, IP, VW, ICON)
  !Υǥå. 
  if (ICON == 30000) then
     error = 'ICON is 30000'
     write(*,*) error
     stop
  elseif (ICON == 20000) then
!     error = 'ICON is 20000'
!     write(*,*) error
     if (present(info)) info = minloc(abs(FB2), 1)
     return
!     stop
  end if

!!!
!!!γΤ餷Υå  
!!!
!  call display_residual(FA2, FB2, B, RR)
!  call residual(FA2, FB2, B, RR)
!  if (maxval(RR) > epsilon(RR) * 1.0d1) then 
!     call stop(maxval(RR), "residual")
!  end if

  !β
  deallocate(FA1, &
       & FB1, &
       & FA2, &
       & FB2, &
       & IP, &
       & RR, &
       & VW)
  
end subroutine matrix_resolv



